# -*- coding: utf-8 -*-
import sys, re, json
from bs4 import BeautifulSoup
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urlparse import urlparse, parse_qs, urljoin
except ImportError:
    from urllib.parse import urlparse, parse_qs, urljoin
if sys.version_info[0] == 3:
    from functools import reduce


def getsoup(url):
    if (2, 7, 3) <= sys.version_info < (3, 0) or (3, 2) <= sys.version_info < (4, 0):
        return BeautifulSoup(urlopen(url), 'html.parser')
    return BeautifulSoup(urlopen(url), 'html5lib')


def getjson(url):
    return json.load(urlopen(url))


def gethttp(url):
    return urlopen(url, timeout=3).read().decode('utf-8')


def play(url):
    def concat(a, b):
        return a + b

    def remove_quotes(s):
        if s is None or len(s) < 2:
            return s
        for quote in ('"', "'",):
            if s[0] == quote and s[-1] == quote:
                return s[1:-1]
        return s

    def parse_js_value(inp):
        inp = re.sub(r'/\*(?:(?!\*/).)*?\*/', '', inp)
        if '+' in inp:
            inps = inp.split('+')
            return reduce(
                concat, map(parse_js_value, inps))
        inp = inp.strip()
        if inp in js_vars:
            return js_vars[inp]
        return remove_quotes(inp)

    try:
        content = gethttp(url)
    except Exception as e:
        return {'code': 'pornhub 100', 'error': str(e)}
    flashvars = re.search(r'var\s+flashvars_\d+\s*=\s*({.+?});', content)
    if not flashvars:
        return {'code': 'pornhub 101'}
    flashvars = flashvars.group(1)
    qualities = []
    try:
        flashvars = json.loads(flashvars)
        for e in flashvars['mediaDefinitions']:
            qualities.append(e['format'] + '_' + str(e['quality']))
        title = flashvars['video_title']
    except Exception as e:
        return {'code': 'pornhub 102', 'error': str(e)}
    assignments = re.search(r'(var\s+media_\d+)', content)
    if not assignments:
        return {'code': 'pornhub 103'}
    offset1 = assignments.start()
    offset2 = content[:offset1].rfind('\n')
    offset3 = content[offset1:].find('\n') + offset1
    assignments = content[offset2:offset3]
    assignments = assignments.split(';')
    js_vars = {}
    for assn in assignments:
        assn = assn.strip()
        if not assn:
            continue
        assn = re.sub(r'var\s+', '', assn)
        vname, value = assn.split('=', 1)
        vname = vname.strip()
        js_vars[vname] = parse_js_value(value)
    urls = []
    for i in range(len(qualities)):
        if 'media_%d' % i in js_vars:
            urls.append({qualities[i]: js_vars['media_%d' % i]})
    return urls


def category(url):
    try:
        soup = getsoup(url)
    except Exception as e:
        return {'code': 'pornhub 200', 'error': str(e)}
    ret = []
    for e in soup.select('li.videoBox'):
        title = e.select_one('span.title').text.strip()
        img = e.select_one('div.phimage img')['data-src']
        plot = []
        plot.append(e.select_one('div.rating-container div.value').text)
        plot.append(e.select_one('var.duration').text)
        plot = '\n'.join(plot)
        ret.append({'title': title, 'url': urljoin(url, e.a['href']), 'img': img, 'plot': plot})
    e = soup.find('li', {'class': 'page_next'})
    if e:
        ret.append({'title': 'Load more', 'url': urljoin(url, e.a['href'])})
    return ret
